// by Xeno
#define THIS_FILE "x_weaponcargor.sqf"
#include "x_setup.sqf"
private "_vec";
PARAMS_1(_vec);

// by Xeno
#define THIS_FILE "x_weaponcargor.sqf"
#include "x_setup.sqf"
private "_vec";
PARAMS_1(_vec);

#define __awc(wtype,wcount) _vec addWeaponCargo [#wtype,wcount];
#define __amc(mtype,mcount) _vec addMagazineCargo [#mtype,mcount];

if (isNil "x_ranked_weapons") then {
		_x_ranked_weapons_w = [
			[
				// private rifles
				[
					["MP5A5",5],["M16A2",5],["G36C_camo",5],["M4A1",5],["SCAR_L_CQC",5],["M16A2GL",5],["M16A4_GL",5],["MP5SD",5]
				],
				// corporal rifles (gets added to private rifles)
				[
					/*["m8_compact_pmc",5],["m8_compact",5],["m8_carbine_pmc",5],*/["BAF_L85A2_RIS_Holo",5],["M4A1_Aim",5],["SCAR_H_CQC_CCO",5],["SCAR_L_STD_HOLO",5],["SCAR_L_CQC_Holo",5],["M4A3_CCO_EP1",5],["M16A4",5],["M4A1_Aim_camo",5]
				],
				// sergeant rifles (gets added to corporal and private rifles)
				[
					/*["m8_carbineGL",1],*/["BAF_L85A2_UGL_Holo",5],["SCAR_L_CQC_EGLM_Holo",5],["M4A1_HWS_GL",5],["M4A1_HWS_GL_camo",5]
				],
				// lieutenant rifles (gets added to...)
				[
					/*["m8_holo_sd",5],*/["M4A1_AIM_SD_camo",5],["M4A1_HWS_GL_SD_Camo",5],["G36_C_SD_camo",5],["SCAR_L_CQC_CCO_SD",5],["SCAR_H_CQC_CCO_SD",5]
				],
				// captain rifles (gets added...)
				[
					/*["m8_carbine",5],["SCAR_L_STD_Mk4CQT",5],["BAF_L85A2_UGL_SUSAT",5],["BAF_L85A2_RIS_SUSAT",5]*/["BAF_L85A2_RIS_ACOG",5],["BAF_L86A2_ACOG",5],["M16A4_ACG",5],["G36A_camo",5],["G36K_camo",5]
				],
				// major rifles (gets...)
				[
					/*["SCAR_L_STD_EGLM_RCO",5],["SCAR_H_STD_EGLM_Spect",5],*/["BAF_L85A2_UGL_ACOG",5],["M4A3_RCO_GL_EP1",5],["M4A1_RCO_GL",5],["M16A4_ACG_GL",5]
				],
				// colonel rifles (...)
				[
				    /*["m8_tws_sd",5],["SCAR_H_STD_TWS_SD",5],["SCAR_L_STD_EGLM_TWS",5],*/["BAF_L85A2_RIS_CWS",5]
				]
			],
			[
				// private sniper rifles
				[					  
				],
				// corporal sniper rifles
				[
				],
				// sergeant sniper rifles
				[
				    ["m8_sharpshooter",1]
				],
				// lieutenant sniper rifles
				[
                   /*["M4SPR",1]*/["SCAR_H_LNG_Sniper_SD",1]
				],
				// captain sniper rifles
				[
                  ["BAF_LRR_scoped",1],["M24_des_EP1",5],["M24",5],["M40A3",5]
				],
				// major sniper rifles
				[
			      /*["M110_NVG_EP1",1]*/ ["DMR",1],["SCAR_H_LNG_Sniper",5]
				],
				// colonel sniper rifles
				[
				  /*["M110_TWS_EP1",1],["BAF_AS50_TWS",1]*/["PMC_AS50_scoped",5],["M107",5]	
				]
			],
			[
				// private MG
				[  		
				],
				// corporal MG
				[
				   ["M240",5],["baf_l7a2_gpmg",5],["M60A4_EP1",5]
				],
				// sergeant MG
				[	
                   ["M249_EP1",5],["m249",5]				
				],
				// lieutenant MG
				[
				    ["baf_l110a1_aim",5],["MG36_camo",5],["Mk_48_DES_EP1",5],["Mk_48",5]
				],
				// captain MG
				[
					/*["m8_SAW",1]*/ ["m240_scoped_EP1",5]		
				],
				// major MG
				[
					["M249_m145_EP1",5]
				],
				// colonel MG
				[
				   /*["M249_TWS_EP1",1]*/
				]
			],
			[
				// private launchers
				[
					["M136",5]
				],
				// corporal launchers
				[	
                    ["SMAW",5]					
				],
				// sergeant launchers
				[
					["STINGER",5]
				],
				// lieutenant launchers
				[
				    ["MAAWS",5]
				],
				// capain launchers
				[				    
				],
				// major launchers
				[    
                    ["JAVELIN",5]				
				],
				// colonel launchers
				[				    
				]
			],
			[
				// private pistols
				[
					["M9",5]
				],
				// corporal pistols
				[
					["M9SD",5]
				],
				// sergeant pistols
				[
					["UZI_EP1",5]
				],
				// lieutenant pistols
				[				
				],
				// captain pistols
				[					
				],
				// major pistols
				[
				],
				// colonel pistols
				[
				]
			]
		];
	_x_ranked_weapons_e = [
		[
			// private rifles
			[
				["FN_FAL",5],["AK_74_GL",5],["Saiga12K",5],["Bizon",5],["AK_74",5],["AK_47_M",5],["AK_47_S",5],["AKS_74",5],["AKS_74_U",5],["Sa58P_EP1",5],["Sa58V_EP1",5],["bizon_silenced",5]
			],
			// corporal rifles (gets added to private rifles)
			[
				["M14_EP1",5],["AKS_74_NSPU",5],["FN_FAL_ANPVS4",5],["AK_74_GL_kobra",5],["AKS_74_kobra",5],["AKS_74_UN_kobra",5],["AK_107_kobra",5],["AK_107_GL_kobra",5],["Sa58V_CCO_EP1",5]
			],
			// sergeant rifles (gets added to corporal and private rifles)
			[
				["AKS_74_pso",5],["AK_107_pso",5],["AK_107_GL_pso",5]
			],
			// lieutenant rifles (gets added to...)
			[
				["Sa58V_RCO_EP1",5]
			],
			// captain rifles (gets added...)
			[
				["AKS_74_GOSHAWK",5]
			],
			// major rifles (gets...)
			[           
			],
			// colonel rifles (...)
			[			    
			]
		],
		[
			// private sniper rifles
			[
			],
			// corporal sniper rifles
			[                
			],
			// sergeant sniper rifles
			[	
                ["VSS_vintorez",5]		    
			],
			// lieutenant sniper rifles
			[
                ["huntingrifle",5]
			],
			// captain sniper rifles
			[
			    ["SVD",5],["SVD_des_EP1",5],["SVD_NSPU_EP1",5]
			],
			// major sniper rifles
			[
		        ["KSVK",5],["BAF_LRR_scoped_w",5]
			],
			// colonel sniper rifles
			[		        
			]
		],
		[
			// private MG
			[
			],
			// corporal MG
			[
				["RPK_74",5]
			],
			// sergeant MG
			[
				["PK",5]
			],
			// lieutenant MG
			[
                ["Pecheneg",5]
			],
			// captain MG
			[             
			],
			// major MG
			[
			],
			// colonel MG
			[
			]
		],
		[
			// private launchers
			[
				["RPG18",5]
			],
			// corporal launchers
			[
				["RPG7V",5]
			],
			// sergeant launchers
			[
				["Igla",5]
			],
			// lieutenant launchers
			[
                ["MAAWS",5]
			],
			// capain launchers
			[				
			],
			// major launchers
			[
               ["MetisLauncher",5]
			],
			// colonel launchers
			[
                
				
			]
		],
		[
			// private pistols
			[
				["Makarov",5]
			],
			// corporal pistols
			[
				["MakarovSD",5]
			],
			// sergeant pistols
			[
                ["Sa61_EP1",5]
			],
			// lieutenant pistols
			[
			],
			// captain pistols
			[
			],
			// major pistols
			[
			],
			// colonel pistols
			[
			]
		]
	];
	
	{GVAR(misc_store) setVariable [_x,[]]} forEach ["PRIVATE","CORPORAL","SERGEANT","LIEUTENANT","CAPTAIN","MAJOR","COLONEL"];
	
	{
		for "_i" from 0 to (count _x) - 1 do {
			_typear = _x select _i;
			if (count _typear > 0) then {
				_rank = switch (_i) do {
					case 0: {
						{
							_ar = GV2(GVAR(misc_store),_x);
							{
								_ar set [count _ar, toUpper(_x select 0)];
								if (GVAR(WithAcre)) then {
									_ar set [count _ar, "ACRE_PRC119"];
								};
							} forEach _typear;
						} forEach ["PRIVATE","CORPORAL","SERGEANT","LIEUTENANT","CAPTAIN","MAJOR","COLONEL"];
					};
					case 1: {
						{
							_ar = GV2(GVAR(misc_store),_x);
							{_ar set [count _ar, toUpper(_x select 0)]} forEach _typear;
						} forEach ["CORPORAL","SERGEANT","LIEUTENANT","CAPTAIN","MAJOR","COLONEL"];
					};
					case 2: {
						{
							_ar = GV2(GVAR(misc_store),_x);
							{_ar set [count _ar, toUpper(_x select 0)]} forEach _typear;
						} forEach ["SERGEANT","LIEUTENANT","CAPTAIN","MAJOR","COLONEL"];
					};
					case 3: {
						{
							_ar = GV2(GVAR(misc_store),_x);
							{_ar set [count _ar, toUpper(_x select 0)]} forEach _typear;
						} forEach ["LIEUTENANT","CAPTAIN","MAJOR","COLONEL"];
					};
					case 4: {
						{
							_ar = GV2(GVAR(misc_store),_x);
							{_ar set [count _ar, toUpper(_x select 0)]} forEach _typear;
						} forEach ["CAPTAIN","MAJOR","COLONEL"];
					};
					case 5: {
						{
							_ar = GV2(GVAR(misc_store),_x);
							{_ar set [count _ar, toUpper(_x select 0)]} forEach _typear;
						} forEach ["MAJOR","COLONEL"];
					};
					case 6: {
						_ar = GV(GVAR(misc_store),COLONEL);
						{_ar set [count _ar, toUpper(_x select 0)]} forEach _typear;
					};
				};
			};
		};
	} forEach (_x_ranked_weapons_w + _x_ranked_weapons_e);
	
	x_ranked_weapons = if (GVAR(player_side) == west) then {_x_ranked_weapons_w} else {_x_ranked_weapons_e};
	_x_ranked_weapons_w = nil;
	_x_ranked_weapons_e = nil;
	
	execFSM "fsms\LimitWeaponsRanked.fsm";
};

[_vec] spawn {
	private ["_vec", "_old_rank", "_index", "_weapons", "_i", "_rk"];
	PARAMS_1(_vec);
	_old_rank = "";
	while {!isNull _vec && alive _vec} do {
		if (_old_rank != rank player) then {
			clearMagazineCargo _vec;
			clearWeaponCargo _vec;
			_old_rank = rank player;
			_index = _old_rank call FUNC(GetRankIndex);
			if (GVAR(player_side) == west) then {
				{
					_weapons = _x;
					for "_i" from 0 to _index do {
						_rk = _weapons select _i;
						{_vec addweaponcargo _x} forEach _rk;
					};
				} forEach x_ranked_weapons;
				
				__awc(Laserdesignator,1)
				__awc(Binocular,1)
				__awc(Binocular_Vector,1)
				if (GVAR(without_nvg) == 1) then {
					__awc(NVGoggles,1)
				};
	__amc(HandGrenade_West,30)
	__amc(Smokeshell,20)
	__amc(Smokeshellred,20)
	__amc(Smokeshellgreen,20)
	__amc(30Rnd_9x19_MP5,30)
	__amc(30Rnd_9x19_MP5SD,30)
	__amc(15Rnd_9x19_M9,30)
	__amc(15Rnd_9x19_M9SD,30)
	__amc(30Rnd_556x45_Stanag,30)
	__amc(30Rnd_556x45_StanagSD,30)
	__amc(30Rnd_556x45_G36,30)
	__amc(30Rnd_556x45_G36SD,30)
	__amc(200Rnd_556x45_M249,30)
	__amc(200Rnd_556x45_L110A1,30)
	__amc(5Rnd_762x51_M24,12)
	__amc(100Rnd_556x45_BetaCMag,30)
	__amc(10Rnd_127x99_M107,12)
	__amc(5Rnd_127x99_as50,12)
	__amc(20Rnd_762x51_B_SCAR,12)
	__amc(20rnd_762x51_SB_SCAR,12)
	__amc(20Rnd_762x51_DMR,12)
	__amc(100Rnd_762x51_M240,30)
	__amc(FlareWhite_M203,20)
	__amc(FlareGreen_M203,20)
	__amc(FlareRed_M203,20)
	__amc(1Rnd_HE_M203,20)
	__amc(1Rnd_Smoke_M203,20)
	__amc(1Rnd_SmokeGreen_M203,20)
	__amc(1Rnd_SmokeRed_M203,20)
	__amc(M136,10)
	__amc(JAVELIN,2)
	__amc(SMAW_HEAA,2)
	__amc(SMAW_HEDP,2)
	__amc(MAAWS_HEAT,2)
	__amc(MAAWS_HEDP,2)
	__amc(Pipebomb,6)
	__amc(Mine,6)
	__amc(Laserbatteries,3)
    __amc(IR_Strobe_Target,3)
    __amc(IR_Strobe_Marker,3)
	__amc(STINGER,4)
			
			} else {
				{
					_weapons = _x;
					for "_i" from 0 to _index do {
						_rk = _weapons select _i;
						{_vec addweaponcargo _x} forEach _rk;
					};
				} forEach x_ranked_weapons;

				__awc(Laserdesignator,1)
				__awc(Binocular,1)
				__awc(Binocular_Vector,1)
				if (GVAR(without_nvg) == 1) then {
					__awc(NVGoggles,1)
				};
				
	__amc(30Rnd_545x39_AK,30)
	__amc(30Rnd_762x39_SA58,30)
	__amc(20Rnd_B_765x17_Ball,30)
	__amc(30Rnd_556x45_Stanag,30)
	__amc(30Rnd_556x45_StanagSD,30)
	__amc(20Rnd_762x51_FNFAL,30)
	__amc(30Rnd_762x39_AK47,30)
	__amc(64Rnd_9x19_Bizon,30)
	__amc(64Rnd_9x19_SD_Bizon,30)
	__amc(20Rnd_9x39_SP5_VSS,12)
	__amc(75Rnd_545x39_RPK,30)
	__amc(FlareWhite_GP25,20)
	__amc(FlareRed_GP25,20)
    __amc(FlareGreen_GP25,20)
	__amc(1Rnd_HE_GP25,30)
	__amc(1Rnd_HE_M203,30)
	__amc(1Rnd_SMOKE_GP25,20)
	__amc(1Rnd_SmokeRed_GP25,20)
	__amc(1Rnd_SmokeGreen_GP25,20)
	__amc(30Rnd_545x39_AKSD,30)
	__amc(100Rnd_762x54_PK,30)
	__amc(8Rnd_B_Saiga12_Pellets,30)
	__amc(10Rnd_762x54_SVD,12)
	__amc(5x_22_LR_17_HMR,12)
	__amc(20Rnd_762x51_DMR,12)	
	__amc(5Rnd_86x70_L115A1,12)
	__amc(8Rnd_9x18_Makarov,30)
	__amc(8Rnd_9x18_MakarovSD,30)
	__amc(MAAWS_HEAT,2)
	__amc(MAAWS_HEDP,2)
	__amc(PG7VL,2)
	__amc(PG7VR,2)
	__amc(OG7,2)
	__amc(RPG18,10)
	__amc(AT13,2)
	__amc(Igla,4)
	__amc(SmokeShellGreen,20)
	__amc(SmokeShellRed,20)
	__amc(SmokeShell,20)
	__amc(HandGrenade_East,30)
	__amc(5Rnd_127x108_KSVK,12)
	__amc(Mine,6)
	__amc(Pipebomb,6)
	__amc(Laserbatteries,3)
	__amc(IR_Strobe_Target,3)
	__amc(IR_Strobe_Marker,3)
			};
			if (GVAR(WithAcre)) then {
				__awc(ACRE_PRC119,1)
			};
		};
		sleep 2.32;
	};
};